
/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client;

import gdistasi.StarzaNet.client.comandi.Comando;
import gdistasi.StarzaNet.client.comandi.ComandoConnessi;
import gdistasi.StarzaNet.client.comandi.ComandoMillis;
import gdistasi.StarzaNet.client.comandi.GestoreComandiClient;
import gdistasi.StarzaNet.server.ConnessioneCaduta;
import gdistasi.StarzaNet.server.Environment;
import gdistasi.StarzaNet.server.Login;
import gdistasi.util.Consolle;

import java.io.IOException;


public class ConnessioneTestuale extends Connessione {
    int id;
    int minuti;
    String server;
    boolean autoConnect;
    boolean reqConnessi;
    
    public ConnessioneTestuale(){
	stop=false;
	id=0;
	minuti=-1;
	gestoreComandi=new GestoreComandiClient(null,null,this);
    }

    public void setServer(String server){
	this.server=server;
    }

    public void setAutoConnect(boolean a){
	this.autoConnect=a;

    }

    public void collegati() throws IOException {
	try {
	    socket=new SocketTesto(new java.net.Socket(server,Environment.porta),null);
	    autentica();

	    if (reqConnessi) getUtentiConnessi(); else 
		aggiungiMinuti();
	} catch(IOException e){
	    System.err.println(e + " Server: "+server);
	    System.exit(1);
	}
    }
    
    public void getUtentiConnessi(){
	ComandoConnessi c=new ComandoConnessi();
	gestoreComandi.eseguiComando(c);
	System.out.println("Connessi:"+c.getConnessi());
    }
    

    public void start() throws IOException {
	if (user!=null){
	    		
	    if (!reqConnessi && minuti==-1){
		System.out.println("Minuti da aggiungere alla connessione (0 per stopparla): ");
		setMinuti(Consolle.readInt(0,120));
	    }
	} else if (minuti!=-1 || reqConnessi){
	    System.err.println("Errore. Impostare il nome utente con -u");
	    System.exit(1);
	} 

	System.err.println("Inserire password: ");
	setPass(Consolle.readString().toCharArray());
	collegati();

    }

	
    public void setReqConnessi(){
	reqConnessi=true;
    }

    public boolean isPronto(){
	return ((user!=null) || (minuti!=-1) || reqConnessi);
    }

    public void setMinuti(int minuti){
	this.minuti=minuti;
    }

    public void setMinuti(String minuti){
	this.minuti=Integer.parseInt(minuti);
    }

    public void setId(int id){
	this.id=id;
    }
    
    public void aggiungiMinuti(){
	Comando c=new ComandoMillis(minuti*60*1000,id,autoConnect);
	gestoreComandi.eseguiComando(c);
	
    }
    
    protected boolean leggiBenvenuto() throws ConnessioneCaduta {
	boolean ris=false;
	if (socket.readLine().equals(Login.benvenuto)) ris=true;
	return ris;
    }
    
}









