/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;


public class FinPassword extends JFrame {
    Container pane;
    JPanel panSup,panInf;
    Connessione connessione;

    JPasswordField passVecchia= new JPasswordField();
    JPasswordField passNuova= new JPasswordField();
    JPasswordField passRiscrivi= new JPasswordField();
	

    public FinPassword(Connessione conn){
	this.connessione=conn;
	setTitle("Cambia password");
	pane=this.getContentPane();
	initComponenti();

	pack();
	
	addWindowListener(new WindowAdapter() {
		public void windowClosing(){
		    esci();
		}
	    });

	show();

    }

    public void initComponenti(){
	panSup=creaPanSup();
	panInf=new JPanel();
	JButton okButton=new JButton("OK");
	JButton cancButton=new JButton("Cancella");
	okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                premutoOk();
            }
        });

	cancButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
		esci();
            }
        });


	
       


	pane.setLayout(new BorderLayout());

	pane.add(panSup,BorderLayout.CENTER);
	pane.add(panInf,BorderLayout.SOUTH);

	panInf.setLayout(new FlowLayout());
	panInf.add(okButton);
	panInf.add(cancButton);


    }

    public JPanel creaPanSup(){
	final Dimension dim=new Dimension(80,19);

	JPanel panSup=new JPanel();
	JLabel vecchia=new JLabel("Vecchia pass:");
	JLabel nuova=new JLabel("Nuova pass:");
	JLabel riscrivi=new JLabel("Riscrivi nuova:");
	
	
	passVecchia.setPreferredSize(dim);	
	passNuova.setPreferredSize(dim);	
	passRiscrivi.setPreferredSize(dim);	
	

	GridBagConstraints gridBagConstraints1=new GridBagConstraints();
	panSup.setLayout(new GridBagLayout());
	
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        panSup.add(vecchia, gridBagConstraints1);
     
	gridBagConstraints1.gridx = 1;
	panSup.add(passVecchia,  gridBagConstraints1);

	
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        panSup.add(nuova, gridBagConstraints1);
        

	gridBagConstraints1.gridx = 1;
	panSup.add(passNuova, gridBagConstraints1);

        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        panSup.add(riscrivi, gridBagConstraints1);
        
	gridBagConstraints1.gridx = 1;
	panSup.add(passRiscrivi, gridBagConstraints1);

	return panSup;
    }


    public void premutoOk(){
	String vec,nuov,ris;

	vec=new String(passVecchia.getPassword());
	nuov=new String(passNuova.getPassword());
	ris=new String(passRiscrivi.getPassword());
	
	if (!nuov.equals(ris)) {
	    JOptionPane.showMessageDialog(
		    this,
		    "Errore nel riscrivere la password!. Teah stai pi attento",
		    "Non dormire",
		    JOptionPane.ERROR_MESSAGE,
		    null
		    );
	    
	} else {
	    this.dispose();
	    connessione.cambiaPass(vec,nuov);
	}


    }


    public void esci(){
	this.dispose();
    }


    public static void main(String[] a){
	FinPassword fin=new FinPassword(null);
	fin.show();
    }




}
