/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

/*
 * Connetti.java
 *
 * Created on 5 febbraio 2002, 18.12
 */

package gdistasi.StarzaNet.client;

import gdistasi.StarzaNet.server.Environment;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.KeyboardFocusManager;
import java.awt.KeyEventDispatcher;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;

/**
 *
 * @author  Giovanni Di Stasi
 */

public class Finconnetti extends javax.swing.JFrame {
    protected GestoreFinLogin gestore;
    Dimension dim;
    String[] users,servers;

    public Finconnetti(GestoreFinLogin gestore, String[] servers,String[] users){
	this.gestore=gestore;
	this.servers=servers;
	this.users=users;
	this.servers=servers;
	initComponents();
	myInit();
	keyEnter();
    }

 
    public void myInit(){
	dim=getToolkit().getScreenSize();
	setLocation(dim.width/2-getWidth(),dim.height/2-getHeight());
    }	
	
   
    private void keyEnter(){
	KeyboardFocusManager keyMan=KeyboardFocusManager.getCurrentKeyboardFocusManager();
	

	keyMan.addKeyEventDispatcher(new KeyEventDispatcher() {
		public boolean dispatchKeyEvent(KeyEvent e){
		    boolean ret=false;
		    if (e.getKeyCode()==KeyEvent.VK_ENTER){

			/*			if (true){
			    System.out.println("TEAH");
			    e.consume();
			    testoPassword.requestFocus();
		
			    ret=false;
			    }
			*/

			if (e.getSource()==testoPassword) {
			    e.consume();
			    butOkActionPerformed(null);
			    ret=false;
			}


			

		    }
		    return ret;
		}
		
	    }); 
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new JPanel();
        butOk = new JButton();
        jPanel2 = new JPanel();
        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        testoPassword = new JPasswordField();

	comboUser = new JComboBox();
	
	for (int i=0; i<users.length; i++){
	    comboUser.addItem(users[i]);
	}

	Dimension dim=new Dimension(120, 21);

        setTitle(Environment.name);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("finConnetti");
        setResizable(false);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        butOk.setText("Ok");
        butOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {

                butOkActionPerformed(evt);
            }
        });
        
        jPanel1.add(butOk);
        
        getContentPane().add(jPanel1, BorderLayout.SOUTH);
        
        jPanel2.setLayout(new GridBagLayout());
        GridBagConstraints gridBagConstraints1;
        
        jPanel2.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, null, Color.white, null, null));
	
	jLabel1.setText("User");
        gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;

	gridBagConstraints1.gridwidth = 1;
	gridBagConstraints1.gridheight = 1;

        gridBagConstraints1.insets = new Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = GridBagConstraints.WEST;
        jPanel2.add(jLabel1, gridBagConstraints1);
        
        jLabel2.setText("Password");
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints1);

        testoPassword.setPreferredSize(dim);
        testoPassword.setMinimumSize(new Dimension(40, 21));
	gridBagConstraints1.gridx = 1;
        gridBagConstraints1.anchor = GridBagConstraints.EAST;
        jPanel2.add(testoPassword, gridBagConstraints1);
        

	labelServer = new JLabel();
        labelServer.setText("Server");
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;

        gridBagConstraints1.anchor = GridBagConstraints.WEST;
	jPanel2.add(labelServer, gridBagConstraints1);

	comboServer = new JComboBox();
	
	for (int i=0; i<servers.length; i++)
	    comboServer.addItem(servers[i]);
	
	comboServer.setEditable(true);
        comboServer.setPreferredSize(dim);
	gridBagConstraints1.anchor = GridBagConstraints.EAST;
	gridBagConstraints1.gridx = 1;
	jPanel2.add(comboServer,gridBagConstraints1);


        comboUser.setEditable(true);
        comboUser.setPreferredSize(dim);
	/*        comboUser.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                comboUserActionPerformed(evt);
            }
	    });*/
        
        gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.anchor = GridBagConstraints.EAST;
        jPanel2.add(comboUser, gridBagConstraints1);
        
        getContentPane().add(jPanel2, BorderLayout.CENTER);
        
        pack();
    }

    private void butOkActionPerformed(ActionEvent evt) {//GEN-FIRST:event_butOkActionPerformed
	String user=(String)comboUser.getSelectedItem();
	user.trim();
	String server;

	server=(String)comboServer.getSelectedItem();
	if (server==null){ 
	    gestore.visualizzaErrore("Inserisci l'indirizzo del server");
	    return;
	}

        gestore.autentica(user,server,testoPassword.getPassword());
    }

    private void exitForm(WindowEvent evt) {
        gestore.exit();
    }
  
   
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {

    }

    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton butOk;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPasswordField testoPassword;
    private javax.swing.JComboBox comboUser;
    private JComboBox comboServer;
    private JLabel labelServer;

}












