/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client;

import gdistasi.StarzaNet.server.ConfException;
import gnu.getopt.Getopt;

import java.io.IOException;
import java.util.prefs.Preferences;

import javax.swing.JOptionPane;


public class Main implements GestoreFinLogin {
    Finconnetti finConnetti;
    Connessione connessione;
    ConnessioneTestuale connTesto;
    Getopt g;
    boolean indOk;
    boolean autoConnect;
    String server;
    Preferences prefs;
    String oldValueServers,oldValueUsers;
    String[] users,servers;
    
     
    public Main(String[] argc){
	connTesto=new ConnessioneTestuale();
	g=new Getopt("geslineclient",argc,"s:m:u:ac");
	prefs=Preferences.userRoot().node("starzaclient");
	oldValueServers=getValue("servers","192.168.1.1");
	servers=oldValueServers.split("[,]");
	oldValueUsers=getValue("users","");
	users=oldValueUsers.split("[,]");
    }

    public void autentica(String user, String server, char[] pass){
	finConnetti.setVisible(false);
	addValue("users",users,user);
	addValue("servers",servers,server);
	connessione=new Connessione(user,server,pass);
    }
    
    public void start() throws IOException {
	int c;
	String arg;
	while ((c = g.getopt()) != -1){
	    switch(c){
	    case 's':
		arg = g.getOptarg();
		server=arg;
		indOk=true;
		connTesto.setServer(arg);
		break;
		//
	    case 'a':
		connTesto.setAutoConnect(true);
		break;
	    case 'u':
		connTesto.setUser(g.getOptarg());
		break;

	    case 'm':
		connTesto.setMinuti(g.getOptarg());
		break;
	    case 'c':
		connTesto.setReqConnessi();
		break;

	    case '?':
		break; // getopt() already printed an error
		//
	    default:
		System.out.print("getopt() returned " + c + "\n");
	    }
	    
	}
	
	if (connTesto.isPronto()){
	    if (indOk) {
		addValue("servers",servers,server);
		connTesto.start();
	    } 	else {
		if (!servers[0].equals("")){
		    connTesto.setServer(servers[0]);
		    connTesto.start();
		} else {	
		    visualizzaErrore("Indica con l\' opzione della riga di comando \"s\" l'indirizzo ip del server\n es. \"-s indirizzo\"");
		    System.exit(1);
		}
	    }
	    
	} else {
	   
	    if (indOk){ 
		servers=new String[1];
		servers[0]=server;
	    }
	    
	    finConnetti=new Finconnetti(this,servers,users);
	    finConnetti.show();
	}
    } 

    public void exit(){
	System.exit(0);
    }
    

    String getValue(String key, String def){
	return prefs.get(key,def);
    }

    void addValue(String key,String[] oldValues,String value){
	int oldIndex;
	StringBuffer newValue=new StringBuffer();

	newValue.append(value);
	for (int i=0; i<oldValues.length; i++){
	    if (!oldValues[i].equals(value)){
		newValue.append(",");
		newValue.append(oldValues[i]);
	    }
	}
	
	prefs.put(key,newValue.toString());

    }


    public void visualizzaErrore(String errore){
	
	if (!connTesto.isPronto())
	JOptionPane.showMessageDialog(
				      null,
				      errore,
				      "Errore",
				      
				      JOptionPane.ERROR_MESSAGE,
				      null
  		    );
	System.err.println("Errore: "+errore);
    }


    public static void main(String argc[]) throws IOException,ConfException {
	Main m=new Main(argc);
	
	m.start();

    }
}










