/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

/*
 * MainWin.java
 *
 * Created on 5 febbraio 2002, 18.28
 */

package gdistasi.StarzaNet.client;

import gdistasi.StarzaNet.client.comandi.VisualizzatoreDati;
import gdistasi.StarzaNet.client.comandi.VisualizzatoreDatiGenerali;
import gdistasi.StarzaNet.client.help.AboutBox;
import gdistasi.StarzaNet.server.gestione.DatiConnessione;
import gdistasi.StarzaNet.server.gestione.DatiGenerali;
import gdistasi.StarzaNet.server.gestione.DatiUtente;
import gdistasi.StarzaNet.server.Environment;

import java.awt.Color;

/**
 *
 * @author  gio
 */
public class MainWin extends javax.swing.JFrame implements ClientLog, VisualizzatoreDati,VisualizzatoreDatiGenerali {
    AboutBox about;
    Connessione gestore;
    MainWinListener listener;
    boolean connesso;
    String titolo;

    /** Creates new form MainWin */
    public MainWin(){

	initComponents();
	
        
    }

    public MainWin(Connessione gestore,String titolo){
	this();
        //butAggiorna.setEnabled(false);
	this.gestore=gestore;
	this.titolo=titolo;
        about=new AboutBox(this);
	listener=new MainWinListener(this);
	addWindowListener(listener);
    }
    
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        butConnetti = new javax.swing.JButton();
        butDisconnetti = new javax.swing.JButton();
        butEsci = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        labelConnesso = new javax.swing.JLabel();
        labelConnessi = new javax.swing.JLabel();
        labelCosto = new javax.swing.JLabel();
        costo = new javax.swing.JLabel();
        labelRisparmio = new javax.swing.JLabel();
        risparmio = new javax.swing.JLabel();
        labelDurata = new javax.swing.JLabel();
        durata = new javax.swing.JLabel();
        connessi = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        areaInfo = new javax.swing.JTextArea();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel5 = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        Generale = new javax.swing.JMenu();
        itemRiepilogo = new javax.swing.JMenuItem();
        itemBacheca = new javax.swing.JMenuItem();
        menuItemPass = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        itemEsci = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        itemConnetti = new javax.swing.JMenuItem();
        itemDisconnetti = new javax.swing.JMenuItem();
        Help = new javax.swing.JMenu();
        itemAbout = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle(Environment.name+" - Connessione a Internet");
        jPanel1.setBorder(new javax.swing.border.MatteBorder(new java.awt.Insets(1, 1, 1, 1), new java.awt.Color(0, 51, 51)));
        butConnetti.setFont(new java.awt.Font("Dialog", 0, 11));
        butConnetti.setText("Connetti");
        butConnetti.setName("butConnetti");
        butConnetti.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butConnettiActionPerformed(evt);
            }
        });

        jPanel1.add(butConnetti);

        butDisconnetti.setFont(new java.awt.Font("Dialog", 0, 11));
        butDisconnetti.setText("Disconnetti");
        butDisconnetti.setName("butDisconnetti");
        butDisconnetti.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butDisconnettiActionPerformed(evt);
            }
        });

        jPanel1.add(butDisconnetti);

        butEsci.setFont(new java.awt.Font("Dialog", 0, 11));
        butEsci.setText("Esci");
        butEsci.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butEsciActionPerformed(evt);
            }
        });

        jPanel1.add(butEsci);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel3.setBorder(new javax.swing.border.MatteBorder(new java.awt.Insets(1, 1, 1, 1), new java.awt.Color(0, 51, 51)));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.TitledBorder(null, "Internet", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times", 0, 12)));
        labelConnesso.setForeground(java.awt.Color.blue);
        labelConnesso.setText("Non connesso");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.ipady = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        jPanel2.add(labelConnesso, gridBagConstraints);

        labelConnessi.setText("Utenti connessi: ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        jPanel2.add(labelConnessi, gridBagConstraints);

        labelCosto.setText("Costo");
        labelCosto.setName("labelDurata");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(labelCosto, gridBagConstraints);

        costo.setText("E. 0");
        costo.setPreferredSize(new java.awt.Dimension(85, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 0, 0);
        jPanel2.add(costo, gridBagConstraints);

        labelRisparmio.setText("Risparmio");
        labelRisparmio.setName("labelDurata");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(labelRisparmio, gridBagConstraints);

        risparmio.setText("E. 0");
        risparmio.setPreferredSize(new java.awt.Dimension(85, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 0, 0);
        jPanel2.add(risparmio, gridBagConstraints);

        labelDurata.setText("Durata");
        labelDurata.setName("labelDurata");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(labelDurata, gridBagConstraints);

        durata.setText("00h 00m 00s");
        durata.setPreferredSize(new java.awt.Dimension(85, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 0, 0);
        jPanel2.add(durata, gridBagConstraints);

        connessi.setText("0");
        connessi.setPreferredSize(new java.awt.Dimension(85, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 0, 0);
        jPanel2.add(connessi, gridBagConstraints);

        jPanel3.add(jPanel2, java.awt.BorderLayout.WEST);

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.X_AXIS));

        jPanel3.add(jPanel6, java.awt.BorderLayout.NORTH);

        areaInfo.setEditable(false);
        areaInfo.setFont(new java.awt.Font("Dialog", 0, 11));
        jScrollPane4.setViewportView(areaInfo);

        jPanel3.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jSeparator1.setMaximumSize(new java.awt.Dimension(5, 5));
        jPanel3.add(jSeparator1, java.awt.BorderLayout.EAST);

        getContentPane().add(jPanel3, java.awt.BorderLayout.CENTER);

        jPanel5.setLayout(new java.awt.GridLayout(0, 2));

        jPanel5.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        getContentPane().add(jPanel5, java.awt.BorderLayout.NORTH);

        Generale.setText("Generale");
        itemRiepilogo.setText("Riepilogo connessioni");
        itemRiepilogo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemRiepilogoActionPerformed(evt);
            }
        });

        Generale.add(itemRiepilogo);

        itemBacheca.setText("Bacheca");
        itemBacheca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemBachecaActionPerformed(evt);
            }
        });

        Generale.add(itemBacheca);

        menuItemPass.setText("Cambia password");
        menuItemPass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemPassActionPerformed(evt);
            }
        });

        Generale.add(menuItemPass);

        Generale.add(jSeparator2);

        itemEsci.setText("Esci");
        itemEsci.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemEsciActionPerformed(evt);
            }
        });

        Generale.add(itemEsci);

        jMenuBar1.add(Generale);

        jMenu2.setText("Internet");
        itemConnetti.setText("Connetti");
        itemConnetti.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemConnettiActionPerformed(evt);
            }
        });

        jMenu2.add(itemConnetti);

        itemDisconnetti.setText("Disconnetti");
        itemDisconnetti.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemDisconnettiActionPerformed(evt);
            }
        });

        jMenu2.add(itemDisconnetti);

        jMenuBar1.add(jMenu2);

        Help.setText("Help");
        itemAbout.setText("About");
        itemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemAboutActionPerformed(evt);
            }
        });

        Help.add(itemAbout);

        jMenuBar1.add(Help);

        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents

    private void menuItemPassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemPassActionPerformed
       gestore.premutoPassword(); // Add your handling code here:
    }//GEN-LAST:event_menuItemPassActionPerformed

    private void itemBachecaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemBachecaActionPerformed
        gestore.premutoBacheca();        // Add your handling code here:
    }//GEN-LAST:event_itemBachecaActionPerformed

    private void itemEsciActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemEsciActionPerformed
        listener.windowClosing();// Add your handling code here:
    }//GEN-LAST:event_itemEsciActionPerformed

    private void itemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemAboutActionPerformed
        about.setVisible(true);
        // Add your handling code here:
    }//GEN-LAST:event_itemAboutActionPerformed

    private void itemDisconnettiActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemDisconnettiActionPerformed
        gestore.premutoDisconnetti();// Add your handling code here:
    }//GEN-LAST:event_itemDisconnettiActionPerformed

    private void itemRiepilogoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemRiepilogoActionPerformed
        gestore.premutoRiepilogo();// Add your handling code here:
    }//GEN-LAST:event_itemRiepilogoActionPerformed

    private void itemConnettiActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemConnettiActionPerformed
        gestore.premutoConnetti();// Add your handling code here:
    }//GEN-LAST:event_itemConnettiActionPerformed

    private void butEsciActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butEsciActionPerformed
        listener.windowClosing();// Add your handling code here:
    }//GEN-LAST:event_butEsciActionPerformed

    private void butConnettiActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butConnettiActionPerformed
        gestore.premutoConnetti();
               
        //butAggiorna.setEnabled(true);
    }//GEN-LAST:event_butConnettiActionPerformed

    private void butDisconnettiActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butDisconnettiActionPerformed
        //butAggiorna.setEnabled(false);
        gestore.premutoDisconnetti();

	
    }//GEN-LAST:event_butDisconnettiActionPerformed

    /** Exit the Application */
    /**
    * @param args the command line arguments
    */

    public void write(String arg){
	areaInfo.append(arg+'\n');
    }
    
    public void exit(){
	gestore.exitMainWin();
    }

    public static void main(String args[]) {
        new MainWin().show();
    }




    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem itemEsci;
    private javax.swing.JLabel labelDurata;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JMenu Help;
    private javax.swing.JMenuItem itemConnetti;
    private javax.swing.JLabel labelConnesso;
    private javax.swing.JLabel labelRisparmio;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel labelCosto;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JLabel labelConnessi;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JMenu Generale;
    private javax.swing.JMenuItem menuItemPass;
    private javax.swing.JButton butEsci;
    private javax.swing.JTextArea areaInfo;
    private javax.swing.JButton butDisconnetti;
    private javax.swing.JMenuItem itemBacheca;
    private javax.swing.JMenuItem itemRiepilogo;
    private javax.swing.JLabel durata;
    private javax.swing.JLabel connessi;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel risparmio;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton butConnetti;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JMenuItem itemDisconnetti;
    private javax.swing.JMenuItem itemAbout;
    private javax.swing.JLabel costo;
    private javax.swing.JMenuBar jMenuBar1;
    // End of variables declaration//GEN-END:variables

    public void writeLineMandata(String s){
	write("--> "+s);
    }

    public void writeLineRicevuta(String s){
	write("<-- "+s);
    }

    public void setConnessi(int c){
	connessi.setText(""+c);
	setTitle(titolo+" "+ c +" ut. conn.");
    }

    public void accettaDatiGenerali(DatiGenerali dati){
	labelConnessi.setText("Utenti connessi: "+dati.getUtentiConnessi());

    }
    
    public void accettaDati(DatiUtente dati){
		
	costo.setText(DatiConnessione.parseValuta(dati.getCostoTotale()));
	risparmio.setText(DatiConnessione.parseValuta(dati.getRisparmioTotale()));
	durata.setText(dati.parseDurata());
	//setConnesso(dati.getConnesso());
    }

    public boolean isConnesso(){
	return connesso;
    }

    public void setConnesso(boolean op){
	if (op){
	    connesso=true;
	    labelConnesso.setText("Connesso");
            labelConnesso.setForeground(Color.red);
        } else { 
	    connesso=false;
	    labelConnesso.setText("Non connesso");
            labelConnesso.setForeground(Color.blue);
           
        }
	
    }
    
}




