/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package  gdistasi.StarzaNet.client.comandi;

import gdistasi.StarzaNet.client.gestione.TableDati;
import gdistasi.StarzaNet.client.gestione.WinLogConnessioni;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;

public class ComandoProspetto extends ComandoBase implements Serializable,Runnable {
    static public String type="comandoProspetto";

    ArrayList riepilogoConnessioni;
    transient Thread thread;

    public ComandoProspetto(){
	riepilogoConnessioni=new ArrayList(30);
    }

    public int getType(){
	return 6;
    }

    public void esegui() throws IOException,ClassNotFoundException {
	riepilogoConnessioni=socket.riceviAr();
	eseguiParteClient();
    }
    
    public void eseguiParteClient(){
	thread=new Thread(this);
	thread.run();
    }


    public void run(){
	//System.out.println(riepilogoConnessioni); 
	TableDati tableModel=new TableDati(riepilogoConnessioni);
	 WinLogConnessioni win=new WinLogConnessioni(tableModel);
	 
	 win.show();
    }
    
    private void writeObject(java.io.ObjectOutputStream out)
	throws IOException {
	out.defaultWriteObject();
	int size=riepilogoConnessioni.size();
	out.writeInt(size);
	for (int i=0; i<size; i++){
	    out.writeObject(riepilogoConnessioni.get(i));
	}
    }

    
    private void readObject(java.io.ObjectInputStream in)
	throws IOException, ClassNotFoundException {
	in.defaultReadObject();
	int size=in.readInt();
	
	riepilogoConnessioni=new ArrayList(size);
	
	for (int i=0; i<size; i++){
	    riepilogoConnessioni.add(in.readObject());
	}	
    }
}





