/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client.comandi;




import gdistasi.StarzaNet.client.Connessione;
import gdistasi.StarzaNet.client.MainWin;
import gdistasi.StarzaNet.client.SocketClient;
import gdistasi.StarzaNet.client.bacheca.Bacheca;
import gdistasi.StarzaNet.server.PassException;

import javax.swing.JOptionPane;

public class GestoreComandiClient {
    SocketClient socket;
    MainWin frame;
    Connessione connessione;
    VisualizzatoreDati vis;
    Bacheca bacheca;
    int connessi;

    public GestoreComandiClient(MainWin frame,VisualizzatoreDati vis,Connessione conn){
	this.frame=frame;
	this.vis=vis;
	this.connessione=conn;
    }

    public void setSocket(SocketClient socket){
	this.socket=socket;
    }



    public VisualizzatoreDati getVisualizzatoreDati(){
	return vis;
    }

    public SocketClient getSocket(){
	return socket;
    }

    public synchronized int esegui(Comando c){
	return eseguiComando(c);
    }

    public Connessione getConnessione(){
	return connessione;
    }

    public synchronized int eseguiComando(Comando c)   {
	int i,ret=0;
	int comando;
	
	try {
	    c.setSocket(socket);
	    c.setGestoreParteClient(this);
	    comando=c.getType();
	    //	    System.out.println("TEAH"+comando);
	    socket.writeInt(comando);
	    c.esegui();
	} catch (java.io.IOException e) {
	    processaErrore(e);
	} catch (ClassNotFoundException e){
	   System.err.println(e);
	} catch (PassException e){
	    JOptionPane.showMessageDialog(
		    frame,
		    "Errore nel cambiamento password",
		    "Errore",
		    
		    JOptionPane.ERROR_MESSAGE,
		    null
		    );
	}
	
	return ret;
    }

    public void setConnesso(boolean connesso){
	frame.setConnesso(connesso);
    }

    public void setConnessi(int connessi){
	this.connessi=connessi;
	
    }

    public int getConnessi(){
	return connessi;
    }

    public void setBacheca(Bacheca bacheca){
	this.bacheca=bacheca;
    }

    public Bacheca getBacheca(){
	return bacheca;
    }

    public void processaErrore(Exception e){
	JOptionPane.showMessageDialog(
		    frame,
		    "Msg di errore: "+e.getMessage(),
		    "Errore",
		    JOptionPane.ERROR_MESSAGE,
		    null
		    );
	System.exit(1);


    }

}


