/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client.gestione;

import gdistasi.StarzaNet.server.gestione.DatiConnessione;
import gdistasi.StarzaNet.server.gestione.DatiConnessioneS;
import gdistasi.StarzaNet.server.gestione.DatiRiepilogo;
import gdistasi.StarzaNet.server.gestione.Selezionatore;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

public class TableDati extends AbstractTableModel {
    DatiConnessioneS datiConnessione;
    DatiRiepilogo[] datiRiepilogo;

    public TableDati(ArrayList dati){
	this.datiConnessione=new DatiConnessioneS(dati);
	datiRiepilogo = new DatiRiepilogo[3];
	preparaDatiRiepilogo();
    }

    protected void preparaDatiRiepilogo(){
	DatiConnessioneS datiNew;

	Selezionatore selez=new Selezionatore();

	
	selez.addCriterioMese(Selezionatore.MESE_CORRENTE);
	datiNew=datiConnessione.filtra(selez);
	datiRiepilogo[0]=datiNew.getDatiRiepilogo();
	datiRiepilogo[0].setTitolo("Mese attuale: ");

	selez.clearCriteri();
	selez.addCriterioMese(Selezionatore.MESE_PREC);
	datiNew=datiConnessione.filtra(selez);
	datiRiepilogo[1]=datiNew.getDatiRiepilogo();
	datiRiepilogo[1].setTitolo("Mese prec: ");
	
	datiNew=datiConnessione;
	datiRiepilogo[2]=datiNew.getDatiRiepilogo();
	datiRiepilogo[2].setTitolo("Totale: ");

    }

    public Class getColumnClass(int colonna){
	Class ret=null;
	if (datiConnessione.size()>0) ret=datiConnessione.get(0).getColumnClass(colonna);
	else ret=new String("fake_string").getClass();
	return ret;
    }

    public String getColumnName(int col){
	return DatiConnessione.getColumnName(col);
    }


    /*    public long durataTotale(DatiConnessione[] dati){
	
	long somma=0;
       	for (int i=0; i<dati.length; i++){
	    somma+=dati[i].getDurata();
	}
	return somma;

	}*/

    public int getColumnCount(){
	return DatiConnessione.getColumnCount();
    }

    public boolean isCellEditable(int row, int col){
	return false;
    }

    public int getRowCount(){
	return getNumRecord()+datiRiepilogo.length+1;
    }

    public int getNumRecord(){
	return datiConnessione.size();
    }

    public Object getValueAt(int row, int col){
	Object ret=null;
	
	String nomeMese=null;

	int meseSel;

	int numRecord=getNumRecord();

	if  (row<numRecord) ret=datiConnessione.get(row).get(col);
	
	if (row==numRecord) {
	    ret=null;  //lascia riga bianca nel prospetto
	}
	
	// se row==numRecord+1  allora row-numRecord-1=0 quindi si ha la visualizzazione di datiRiepilogo[0] sulla prima riga dopo quella vuota (la riga vuota corrisponde a row=numRecord;

	if (row>numRecord) {
	    ret=datiRiepilogo[row-numRecord-1].get(col);
	}
	
	
	return  ret;

    }


    protected Object rowRecord(String nomeMese,int col,float[] totali,long durataTotale){
	Object ret=null;

	switch (col){
		case 0: 
		ret=new  String("Tot. "+nomeMese);
		break;
	    case 2:
		ret=DatiConnessione.parseDurata(durataTotale);
		break;
	    case 3: 
		ret=DatiConnessione.parseValuta(totali[0]);
		break;
	    case 4: 
		ret=DatiConnessione.parseValuta(totali[1]);
		break;
	    default:
		break;
	    }

	return ret;

    }

}
