/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client.help;


import gdistasi.StarzaNet.server.Environment;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;

import java.io.*;

public class AboutBox extends JDialog
{
  public AboutBox(Frame owner) {
    super(owner, "About gesline", true);

    JLabel lbl = new JLabel(new ImageIcon("icon.gif"));
    JPanel p = new JPanel();
    Border b1 = new BevelBorder(BevelBorder.LOWERED);
    Border b2 = new EmptyBorder(5, 5, 5, 5);
    lbl.setBorder(new CompoundBorder(b1, b2));
    p.add(lbl);
    getContentPane().add(p, BorderLayout.WEST);



    String message = "gesline Client "+Environment.VERSION+"\n"+
	"Copyright 2002-2004 Giovanni Di Stasi <gdistasi@tiscali.it>\nEra starzanet\n\n";

    StringBuffer licenza = new StringBuffer(caricaMessaggio());
    licenza.insert(0,message);
    
    JTextArea txt = new JTextArea(licenza.toString());
    txt.setBorder(new EmptyBorder(5, 10, 5, 10));
    txt.setFont(new Font("Helvetica", Font.BOLD, 12));
    txt.setEditable(false);
    txt.setBackground(getBackground());
    p = new JPanel();
    p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
    p.add(txt);

    message = "\n"+
      "";
    txt = new JTextArea(message);
    txt.setBorder(new EmptyBorder(5, 10, 5, 10));
    txt.setFont(new Font("Arial", Font.PLAIN, 12));
    txt.setEditable(false);
    txt.setBackground(getBackground());
    p.add(txt);
        
    getContentPane().add(p, BorderLayout.CENTER);

    JButton btOK = new JButton("OK");
    ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        setVisible(false);
      }
    };
    btOK.addActionListener(lst);
    p = new JPanel();
    p.add(btOK);
    getContentPane().add(p, BorderLayout.SOUTH);

    pack();
    setResizable(false);
  }

    public String caricaMessaggio(){
	String ret=new String("");
	
	try {

            InputStream str=getClass().getResourceAsStream("/LICENSE");
	    BufferedReader reader = new BufferedReader(
	       new InputStreamReader(str,"ISO-8859-1"));
	    
	    StringBuffer buf=new StringBuffer();
	    
	    String letto;
	    while ((letto=reader.readLine())!=null)
		buf.append(letto+"\n");
	
	    ret = buf.toString();
	} catch (IOException e) {
	    System.err.println("Errore in caricamento licenza "+ e);
	}

	return ret;
    }


}




