/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package  gdistasi.StarzaNet.server;


import java.util.Iterator;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;


public class AutoTimeout {
    Vector timeoutUtenti;
    Connessione  conn;
    int riconnessioni;
    boolean autoConnect;
    Logger log;

    static final long STOP=0;
    
    public AutoTimeout(Connessione conn){
	timeoutUtenti=new Vector(2);
	this.conn=conn;
	this.log=Environment.getLogger();
	
    }

    public synchronized void clearNonAuto(){
	TimeoutUtente tim;
	Iterator it=timeoutUtenti.iterator();
	timeoutUtenti.clear();
//	while (it.hasNext()){	
	    //	    tim=(TimeoutUtente)it.next();
	    // if (!tim.isAutoConnect()){
//		timeoutUtenti.remove(tim);
		// }
//	}

    }

    public synchronized void aggiungiMillis(Utente utente,long millis,int ID,boolean autoConnect){
	TimeoutUtente tim=new TimeoutUtente(utente,millis,ID,autoConnect);
	int pos=timeoutUtenti.indexOf(tim);

	
	if (pos==-1) { 
	    if (millis!=AutoTimeout.STOP){
		timeoutUtenti.add(tim);
		conn.connetti(utente);
	    }

	    log.log(Level.INFO,"Nuovo utente connesso con  interfaccia testuale");
	    if (autoConnect) log.log(Level.INFO,"con riconnessione automatica");
	} else ((TimeoutUtente)(timeoutUtenti.get(pos))).aggiungiMillis(millis);
    }


    public synchronized void aggiornaTimeout() {
	TimeoutUtente tim;
	for (int i=0; i<timeoutUtenti.size(); i++) {
	    tim=(TimeoutUtente)timeoutUtenti.get(i);
	    Utente ut=tim.getUtente();
	    if (tim.getMillis()>0) {
		//		System.out.println("TIM"+tim.getMillis());
		if (!ut.isConnesso()){
		    if (tim.isAutoConnect()) {
			riconnetti(tim);
			log.log(Level.INFO,"Riconnessione per "+ut);
			riconnessioni++;
		    }
		} 
		
		tim.aggiornaTimeout();
	    } else {
		conn.disconnetti(ut);
		timeoutUtenti.remove(tim);
		log.log(Level.INFO,
	        "connessione testuale terminata normalmente per utente "+ut);
	    }
	    
	}
    }

    protected synchronized void riconnetti(TimeoutUtente tim){
	int prove=0;
	Utente ut=tim.getUtente();

	try {
	    while (!ut.isConnesso()){
		conn.connetti(ut);
		Thread.sleep(1000);
		prove++;
		if (prove>300){ 
		    log.log(Level.INFO,"Troppi tentativi di riconnessione falliti...");
		    timeoutUtenti.remove(tim);
		    break;
		}
		log.log(Level.INFO,"Riconnesso per "+ut+" dopo "+prove+" tentativi");
	    }
	} catch (InterruptedException e){
	    log.log(Level.INFO,e.getMessage());
	}
	
    }
}



class TimeoutUtente {
    int ID;
    Utente utente;
    long millis;
    long ultimoAgg;
    boolean autoConnect;
    
    
    public  TimeoutUtente(Utente utente,long millis,int ID,boolean autoConnect){
	this.utente=utente;
	this.millis=millis;
	this.ID=ID;
	this.autoConnect=autoConnect;
	ultimoAgg=System.currentTimeMillis();
    }
    
    public void  aggiungiMillis(long mill){
	if (mill==AutoTimeout.STOP) { 
	    this.millis=0;
	    
	    return;
	}
	
	this.millis+=mill;
    }
    
    public boolean isAutoConnect(){
	return false;
    }
    
    public long getMillis(){
	return millis;
    }
    
    public Utente getUtente(){
	return utente;
    }
    
    public void aggiornaTimeout(){
	long temp=System.currentTimeMillis();
	long diff=temp-ultimoAgg;
	
	if (diff<0) { 
	    System.err.println("errore in AutoTimeout! E' stato cambiato l'orario di sistema?");
	    millis=0;
	    
	    return;
	}
	
	utente.aggiornaTimeout(temp);
	millis-=diff;
	
	ultimoAgg=temp;
    }
    
    public boolean equals(Object o){
	TimeoutUtente ob=(TimeoutUtente)o;
	boolean ris=(ID==ob.ID)&&(utente.toString().equals(ob.utente.toString()));
	//System.out.println("INS"+ris);
	return ris;    
    }

}
