/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;

import gdistasi.StarzaNet.server.comandi.Comando;
import gdistasi.StarzaNet.server.comandi.GestoreComandi;

import java.io.EOFException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;




public class ConsolleComandi {
    protected MySocket socket;
    protected Utente utente;
    protected GestoreComandi gestoreComandi;
    protected int esito;
    Logger log;

    static final String[] errori=new String[30];
    static {
	errori[1]="Comando non riconosciuto";
	errori[0]="OK";
	errori[2]="Utente gia connesso";
	errori[3]="errore3";
	errori[4]="utente non risulta collegato";
	errori[5]="err. in connessione ad internet. Consultare l'amministratore";
	errori[6]="errore nello stop della connessione";
	errori[9]="errore in avvio connessione ad internet";
	errori[10]="utente non connesso";
    }



    public ConsolleComandi(MySocket socket,GestoreComandi gestoreComandi,Utente utente){
	this.socket=socket;
	this.utente=utente;
	this.gestoreComandi=gestoreComandi;
	this.log=Environment.getLogger();
    }

    public void attendiComandi() throws IOException {
	int intComando;
	Comando comando=null;
	boolean stop=false;

	socket.writeLine(Login.loginCorretto);
	
	try {
	    while (!stop) {
		intComando=socket.readInt();
		comando=gestoreComandi.riconosciComando(intComando);
		if (comando!=null) {
	     		preparaEdEsegui(comando);	
		}
		else {
		    log.severe("Errore in attendiComandi"+comando);
		    socket.close();
		    stop=true;
		}
	    }
	} catch (EOFException e){
	    log.log(Level.INFO,"Connection closed from user: "+utente.toString());
	} catch (IOException e){
	    //e.printStackTrace();
	}
    }
	
	
	
    public void preparaEdEsegui(Comando comando) throws IOException {
	comando.setUtente(utente);
	comando.setSocket(socket);
	gestoreComandi.esegui(comando);
    }

    public void riportaEsito(){
	socket.writeLine(errori[esito]);
    }

}
































































































































