/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


public class ErrorHandlerMy implements ErrorHandler {
    Logger log;

    public ErrorHandlerMy(Logger log){
	this.log=log;
    }


    public void error(SAXParseException e) throws SAXException { 
	log.log(Level.SEVERE,e.getMessage()+"\nParsing error: line "+ e.getLineNumber()+" in column "+
		e.getColumnNumber());
	System.exit(5);
    }


    public void fatalError(SAXParseException e) throws SAXException {
	error(e);
    }


    public void warning(SAXParseException e) throws SAXException {
	error(e);
    }




}
