/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class MySocket {
    Socket socket;
    protected ObjectOutputStream out;
    protected ObjectInputStream in;


    public MySocket(){

    }

    public synchronized void setSocket(Socket socket){
	this.socket=socket;
    }

    public MySocket(Socket socket){
	this.socket=socket;

	try {
	    in=new ObjectInputStream(getInputStream());
	    out=new ObjectOutputStream(getOutputStream());
	    
	    
	} catch (IOException e) {   System.out.println(""+e); }    
	
    }
 
    public  synchronized void writeUTF(String s) throws IOException {
	out.writeUTF(s);
       out.flush();
    }

    public  synchronized String readUTF() throws IOException {
	String s=in.readUTF();
	return s;
    }

    public  synchronized void writeLine(String s) {
	try {    
	    out.writeObject(s);
	    out.flush();
	} catch (IOException e){
	    System.err.println(e);
	    //close();
	}
    }

    public synchronized  void writeObject(Object ob) throws IOException {
	out.writeObject(ob);
	out.flush();
    }
    

    public  synchronized void writeLine(char[] s) {
	String temp=new String(s);
	writeLine(temp);
    }
    
    public synchronized void close(){
	try {
	    socket.close();
	} catch (IOException e) { System.err.println(""+e);}
    }

    public synchronized  void invia(ArrayList ar) throws IOException {
	inviaArrayList(ar);
    }

    public  synchronized Object readObject() throws IOException,ClassNotFoundException  {
	return in.readObject();
    }

    public synchronized int readInt() throws IOException {
	return in.readInt();
    }

    public synchronized void writeInt(int i) throws IOException {
	out.writeInt(i);
	out.flush();
    }

    public synchronized void inviaArrayList(ArrayList ar) throws IOException {

	out.writeInt(ar.size());
	for (int i=0; i<ar.size(); i++){
	    out.writeObject(ar.get(i));
	} 

	out.flush();
    }

    public synchronized InetAddress getInetAddress(){
	return socket.getInetAddress();
    }

    public synchronized OutputStream getOutputStream(){
	OutputStream out=null;
	try {
	    out=socket.getOutputStream();
	} catch (IOException e) {}
	return out;
    }

    public synchronized InputStream getInputStream() throws IOException {
	return socket.getInputStream();
    }

    public synchronized  String readLine() throws ConnessioneCaduta {
	String ret=null;
	try {
	    ret=(String)in.readObject();
	} catch (IOException e) { 
	    System.err.println("err. in readLine:"+e);
	    throw new ConnessioneCaduta();
	} catch (ClassNotFoundException e){
	    System.err.println("err. in readLine:"+e);
	    throw new ConnessioneCaduta();
	}
	return ret;
    }

    public  synchronized void invia(int i) throws IOException {
	out.writeInt(i);
	out.flush();

    }

    public synchronized  void invia(float f) throws IOException {
	out.writeFloat(f);
	out.flush();
    }

    public synchronized float riceviFloat() throws IOException {
	return in.readFloat();
    }

    public synchronized boolean riceviBoolean() throws IOException {
	boolean b=in.readBoolean();
	return b;
    }

    public  synchronized void invia(boolean b) throws IOException {
	out.writeBoolean(b);
	out.flush();
    }

    public  synchronized void invia(Object o) throws IOException {
	out.writeObject(o);
	out.flush();
    }

    public  synchronized void invia(long l) throws IOException {
	out.writeLong(l);	
	out.flush();
    }

    public synchronized long riceviLong() throws IOException {
	return in.readLong();
    }

    public synchronized int riceviInt() throws IOException {
	return in.readInt();
    }


    static synchronized public void invia(List ar,ObjectOutputStream out) throws IOException  {
	int size=ar.size();
	out.writeInt(ar.size());

	Iterator i=ar.iterator();
	while (i.hasNext()){
	    out.writeObject(i.next());
	    //System.out.println(ar.get(i));
	}

	out.flush();

    }

    public synchronized Object riceviObj() throws IOException,ClassNotFoundException {
        return in.readObject();
    }


    public synchronized ArrayList riceviAr() throws IOException,ClassNotFoundException {
	return ricevi(in);
    }


    static  synchronized public ArrayList ricevi(ObjectInputStream in) throws IOException,ClassNotFoundException {
	ArrayList ar;
	int size=in.readInt();

	ar=new ArrayList(size);
	for(int i=0;  i<size; i++){
	    Object ob=in.readObject();
	    ar.add(ob);
	}
	return ar;
    }
}










