/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.bacheca;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.LinkedList;
import java.util.List;

public class FileMessaggi {
    FileOutputStream fileOut;
    FileInputStream fileIn;
    LinkedList messaggi;
    String filename;

    static long limite=60*60*60*24*4; //4 giorni

    public FileMessaggi(String filename){
	this.filename=filename;
	messaggi=new LinkedList();
    }

    public void salvaSuDisco() throws IOException {
	RandomAccessFile fileOut=new RandomAccessFile(filename,"rw");
	

	int numElem=size();

	fileOut.writeInt(numElem);
	for (int i=0; i<numElem; i++){
	    ((Messaggio)messaggi.get(i)).writeObject(fileOut);
	}
	
	fileOut.close();       
    }



    protected void carica() throws IOException {
	RandomAccessFile file=new RandomAccessFile(filename,"r");
	Messaggio msg=null;

	int num=0;
	

	try {
	    num=file.readInt();
	    for (int i=0; i<num; i++){
		msg=new Messaggio();
		msg.readObject(file);
		messaggi.addLast(msg);	
	    }    
	} catch (IOException e){
	    System.err.println("Errore in caricamento messaggi "+e);
	}
	file.close();

	//System.out.println(num+ " NUMERO MESSAGGI CARICATI"+messaggi.size());
    }
    

    public List getMessaggi() throws IOException {
	//carica();
	return messaggi;
    }

    public int size(){
	return messaggi.size();
    }

    public void cancellaMessaggiVecchi() throws IOException {
	long currTime=System.currentTimeMillis();
	
	/*
	for (int i=0;i<size();i++){
	    if (currTime-((Messaggio)messaggi.get(i)).getTime()>limite){
		messaggi.remove(i);
		i--;
	    }
	}
	salvaSuDisco();
	*/
    }


    public void add(Messaggio msg) throws IOException { 
	
	messaggi.addLast(msg);

	//System.out.println(messaggi.size());

	RandomAccessFile file=new RandomAccessFile(filename,"rw");
	file.writeInt(messaggi.size());
	
	file.seek(file.length());

	msg.writeObject(file);

	file.close();
	
	
    }
}
