/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.bacheca;


import gdistasi.StarzaNet.server.Utente;
import gdistasi.StarzaNet.server.gestione.DatiConnessione;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Date;



public class Messaggio implements java.io.Serializable {
    String utente;
    long data;
    String testo;


    public Messaggio(Utente utente,String msg){
	setUtente(utente);
	setTesto(msg);
	data=System.currentTimeMillis();

    }

    public Messaggio(){

    }

    public Messaggio(String testo){
	this(new Utente("null",null,null),testo);
    }

    public void setUtente(Utente utente){
	this.utente=utente.toString();
    }
    
    public long getTime(){
	return data;
    }

    public void setTesto(String testo){
	this.testo=testo;
    }

    public String getTesto(){
	return testo;

    }

    public void  readObject(RandomAccessFile file) throws IOException {
	utente=file.readUTF();
	testo=file.readUTF();
	data=file.readLong();
    }

    public void writeObject(RandomAccessFile file) throws IOException {
	file.writeUTF(utente);
	file.writeUTF(testo);
	file.writeLong(data);
    }


    public String toString(){
	return getTestoEsteso();
    }


    public String getTestoEsteso(){
	StringBuffer buf=new StringBuffer(70);


	buf.append(DatiConnessione.dataToString(new Date(data))+" ");
	buf.append(DatiConnessione.getStringOraInizio(data)+" ");
	buf.append(utente.toString()+": ");
	buf.append(testo);
	
	return buf.toString();
    }


}
