/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package  gdistasi.StarzaNet.server.comandi;

import gdistasi.StarzaNet.server.gestione.DatiConnessioneS;
import gdistasi.StarzaNet.server.gestione.FileDatiGenerali;
import gdistasi.StarzaNet.server.gestione.FileDatiUtente;
import gdistasi.StarzaNet.server.gestione.Selezionatore;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;

public class ComandoProspetto extends ComandoBase implements Serializable {
    static public String type="comandoProspetto";

    transient FileDatiUtente fileDatiUtente;
    transient FileDatiGenerali fileDatiGenerali;
    ArrayList riepilogoConnessioni;
    Selezionatore selezionatore;

    public ComandoProspetto(){
	riepilogoConnessioni=new ArrayList(30);
	selezionatore=new Selezionatore();
	selezionatore.addCriterioMese(Selezionatore.MESE_CORRENTE);
	selezionatore.addCriterioMese(Selezionatore.MESE_PREC);
    }

    public void esegui() throws IOException {
	eseguiParteServer();
	socket.invia(riepilogoConnessioni);
    }
    
    public void eseguiParteServer(){
	int size=0;	
	DatiConnessioneS dati;
	try {    
	    fileDatiUtente=utente.getFileDatiUtente();
	    fileDatiGenerali=gesServer.getConnessione().getFileDatiGenerali();
	    fileDatiGenerali.leggiFile();
	    fileDatiUtente.leggiFile();
	    fileDatiUtente.aggiungiCostoFisso(fileDatiGenerali);
	    dati=fileDatiUtente.getTutto();
	    dati=dati.filtra(selezionatore);
	    riepilogoConnessioni=dati.getArrayList();
	} catch (java.io.IOException e){
	    System.err.println(e);
	    exception=e;	
	}
    }

    private void writeObject(java.io.ObjectOutputStream out)
	throws IOException {
	out.defaultWriteObject();
	int size=riepilogoConnessioni.size();
	out.writeInt(size);
	for (int i=0; i<size; i++){
	    out.writeObject(riepilogoConnessioni.get(i));
	}
    }

    
    private void readObject(java.io.ObjectInputStream in)
	throws IOException, ClassNotFoundException {
	in.defaultReadObject();
	int size=in.readInt();
	
	riepilogoConnessioni=new ArrayList(size);
	
	for (int i=0; i<size; i++){
	    riepilogoConnessioni.add(in.readObject());
	}	
    }
}





