/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.comandi;

import gdistasi.StarzaNet.server.MySocket;
import gdistasi.StarzaNet.server.bacheca.FileMessaggi;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;


public class ComandoRiceviMessaggi extends ComandoBase implements Serializable {
    static public String type="comandoRiceviMessaggi";

    List messaggi;
    transient FileMessaggi fileMessaggi;
	    
    public ComandoRiceviMessaggi(){
	//System.out.println("sto eseguendo...");
	messaggi=new LinkedList();
    }

    public void esegui() throws IOException {
	eseguiParteServer();
	socket.invia(new ArrayList(messaggi));
    }

    public void eseguiParteServer(){
	int ris;
	this.fileMessaggi=getGestoreParteServer().getBacheca().getFileMessaggi();
	try {
	    messaggi=fileMessaggi.getMessaggi();

	    //System.out.println("MEssaggi"+messaggi);
	} catch (java.io.IOException e){
	    exception=e;
	}
  
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
	out.defaultWriteObject();
	//System.out.println("sto inviando i  messaggi");
	MySocket.invia(messaggi,out);
    }

    private void  readObject(ObjectInputStream in) throws IOException,ClassNotFoundException  {
	in.defaultReadObject();	
	messaggi=MySocket.ricevi(in);	
	//System.out.println("poi questo..."+messaggi);
    }

}



