/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.gestione;

import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;




public class Bolletta {
    Selezionatore selezionatore;

    String TUTTI="all";
    int mese;

    long durataTotale;
    float costoTotale;
    float risparmioTotale;
    int numUtenti;

    public Bolletta(Selezionatore selez){
	this.selezionatore=selez;
    }
    
    public void stampaUtente(String ut) {
	float[] tot;
	long durata;
	DatiConnessioneS dati,datiOld;

	try {
	    //	    System.out.println("TETETE");

	    FileDatiUtente fileDatiUtente=new FileDatiUtente(ut);
	    FileDatiGenerali fileDatiGenerali=new FileDatiGenerali();
	    fileDatiGenerali.leggiFile();
	    fileDatiUtente.leggiFile();
	    fileDatiUtente.aggiungiCostoFisso(fileDatiGenerali);
	    
	    datiOld=fileDatiUtente.getTutto();  
	    

	    dati=datiOld.filtra(selezionatore);
	    
	    System.out.println();
	    System.out.println("UTENTE: "+ut);
	    
	    tot=dati.getTotali();
	    durata=dati.getDurataTotale();
	    
	    numUtenti++;
	    costoTotale+=tot[0];
	    risparmioTotale+=tot[1];
	    durataTotale+=durata;
	    
	    stampaHeader(tot[0],tot[1],durata);
	    DatiConnessione.stampa(dati,System.out);
	    
	} catch (IOException e){
	    System.err.println("Errore per il riepilogo dell'utente: "+ut);
	}
    }
    
    

    public void stampaHeader(float costo,float risparmio,long durata){
	PrintStream  out=System.out;
	
	out.print("COSTO TOTALE: ");
	out.println(DatiConnessione.parseValuta(costo));
	out.print("RISPARMIO TOTALE: ");
	out.println(DatiConnessione.parseValuta(risparmio));
	out.print("DURATA TOTALE: ");
	out.print(DatiConnessione.parseDurata(durata));
	out.println();
    }
    
    
    public void stampaTutti(){
	DatiConnessioneS dati,datiOld;
	float tot[];
	long durata;
	
	try {
	    FileDatiGenerali fileDatiGenerali=new FileDatiGenerali();
	    fileDatiGenerali.leggiFile();
	    datiOld=fileDatiGenerali.getTutto();
	    
	    dati=datiOld.filtra(selezionatore);
	    
	    tot=dati.getTotali();
	    durata=dati.getDurataTotale();
	    
	    System.out.println();
	    stampaHeader(tot[0],tot[1],durata);
	    DatiConnessione.stampa(dati,System.out);
	    
	} catch (IOException e){
	    System.err.println("Errore in lettura");
	}
    }
    
    public void stampa(String ut){
	if (ut.equals(TUTTI)) {
	    stampaTutti();
	} else {
	    stampaUtente(ut);
	}
	
    }
    
    
    public void stampaUtenti(ArrayList utenti) {
	
	//System.out.println(utenti);

	for (int j=0; j<utenti.size(); j++){
	    //	    System.out.println("2");
	    stampa((String)utenti.get(j));
	}
	
	if (numUtenti>1) {
	    System.out.println();
	    System.out.println("TOTALI UTENTI CONSIDERATI");
	    stampaHeader(costoTotale,risparmioTotale,durataTotale);
	}
    }
}






































































































