/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.gestione;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.RandomAccessFile;


public class DatiGenerali extends DatiConnessione implements java.io.Serializable,Cloneable {
    int utentiConnessi;
    int utentiPerCostoFisso;
    float costoFissoConnessione;
    String nomeConnessione;

    public DatiGenerali(){
	super(0);
	nomeConnessione=new String("");
    }

    public DatiGenerali(long inizio){
	super(inizio);

    }

    public float getCostoTotale(){
	return getCosto()+getCostoFissoConnessione();
    }

    public float getRisparmioTotale(){
	return getRisparmio();

    }

    public float  getCostoFissoPerUtente(){
	float ris=0;
	if (utentiPerCostoFisso==0){ 
	    System.err.println("errore in getCostoFissoPerUtente in datiGenerali");
	    ris=0.5F;
	} else ris=costoFissoConnessione/utentiPerCostoFisso;
	return ris;
    }

    public void setInizio(long inizio){
	super.setInizio(inizio);
	utentiConnessi=0;
	utentiPerCostoFisso=0;
	costoFissoConnessione=0;
    }

    public void stampa(OutputStream out){
	super.stampa(out);
	PrintStream pr=new PrintStream(out);
	
	pr.println("Utenti connessi: "+utentiConnessi);
	pr.println("Utenti per costo fisso: "+utentiPerCostoFisso);
	pr.println("Spesa fissa connessione: "+costoFissoConnessione);

    }

    public int getUtentiConnessi(){
	return utentiConnessi;
    }
    
    public void aggiungiUtentePerCostoFisso(){
	utentiPerCostoFisso++;
    }

    public void setUtentiConnessi(int u){
	utentiConnessi=u;
    }

    public void stampaRecord(PrintStream out){
	super.stampaRecord(out);
	System.out.print(nomeConnessione);

    }

    public void setCostoFissoConnessione(float  costo){
	costoFissoConnessione=costo;
    }

    public float getCostoFissoConnessione(){
	return costoFissoConnessione;
    }
    
    
    public void setNomeConnessione(String nome){
	nomeConnessione=nome;

    }


    public void writeObject(RandomAccessFile s) throws IOException {
	super.writeObject(s);    
	s.writeInt(utentiConnessi);
	s.writeInt(utentiPerCostoFisso);
	s.writeFloat(costoFissoConnessione);
	s.writeUTF(nomeConnessione);
    }
    
    public void readObject(RandomAccessFile s) throws IOException {
	super.readObject(s);
	utentiConnessi=s.readInt();
	utentiPerCostoFisso=s.readInt();
	costoFissoConnessione=s.readFloat();
	nomeConnessione=s.readUTF();
    }
  
}
