/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.gestione;


import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.RandomAccessFile;
import java.io.Serializable;

public class DatiUtente extends DatiConnessione implements Cloneable,Serializable {
    
    long idConnessione;
    float costoFisso;
    float costoFissoVirtuale;
    boolean connesso;

    public DatiUtente(long inizio){
	super(inizio);
    }

    public DatiUtente(){
	this(0);
    }

    public void setConnesso(boolean connesso) {
	this.connesso=connesso;
    }

    public boolean getConnesso(){
	return connesso;
    }

    public float getCostoTotale(){
	return costo+costoFisso;
    }

    public void setSpesaVirtuale(float spesa){
	risparmio=spesa-costo;

    }

    public void setCostoFissoVirtuale(float spesa){
	costoFissoVirtuale=spesa;
    }

    public float getCostoFissoVirtuale(){
	return costoFissoVirtuale;
    }

    public float getRisparmioCostoFisso(){
	return costoFissoVirtuale-costoFisso;
    }

    public float getRisparmioTotale(){
	return risparmio+getRisparmioCostoFisso();
    }

    public void setIdConnessione(long idConnessione){
	this.idConnessione=idConnessione;
    }

    public long getIdConnessione(){
	return idConnessione;
    }

    public void writeObject(RandomAccessFile s) throws IOException {    
	super.writeObject(s);
	s.writeLong(idConnessione);
	s.writeFloat(costoFisso);

	s.writeFloat(costoFissoVirtuale);

    }
    
    public void readObject(RandomAccessFile s) throws IOException {
	super.readObject(s);
	idConnessione=s.readLong();
	costoFisso=s.readFloat();
	costoFissoVirtuale=s.readFloat();

    }



    /*public void writeObject(java.io.ObjectOutputStream out)
	throws IOException {
	super.writeObject(out);
	out.defaultWriteObject();
	out.writeFloat(costo);
	
	//System.out.println("CIAIAIACIACIACIAI "+costo);
	
	out.writeFloat(risparmio);
	out.writeLong(fine);
    }
    
    public void readObject(java.io.ObjectInputStream in)
	throws IOException, ClassNotFoundException {
	super.readObject(in);
	in.defaultReadObject();
	costo=in.readFloat();
	
	//System.out.println("HO LETTO"+costo);
	
	risparmio=in.readFloat();
	fine=in.readLong();
	
	//System.out.println("DURATA"+fine+" "+inizio+"  " +parseDurata());

	}*/
    

    public void stampa(OutputStream out){
	super.stampa(out);
	PrintStream pr=new PrintStream(out);
	pr.println("idConnessione:"+idConnessione);
	pr.println(getDurata());
	pr.println("Costo: "+(getCostoTotale()));
	pr.println("Risparmio: "+ (getRisparmioTotale()));
     }
    
    public void setInizio(long  inizio){
	super.setInizio(inizio);
	costoFisso=0;
	costoFissoVirtuale=0;

    }

    public  void setCostoFisso(float costo){
	this.costoFisso=costo;
    }

}
















