/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.gestione;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.ArrayList;


public class FileDatiConnessione {
    String filename;
    DatiConnessione dati;
    
    public FileDatiConnessione(String filename) throws IOException {
	this.filename=filename;
    }

    public synchronized void salva(DatiConnessione dati) throws IOException{
	RandomAccessFile file=new RandomAccessFile(filename,"rw");
	long length=-1;
	
	try {
	    if (dati.getInizioNelFile()!=-1) {
		file.seek(dati.getInizioNelFile());
		dati.writeObject(file);
	    } else {
		length=file.length();
		file.seek(length);
		dati.setInizioNelFile(length);
		dati.writeObject(file);
	    }
	    file.close();
	} catch (IOException e){
	    file.close();
	    e.printStackTrace();
	    throw e;    
	}
	
    }

    public synchronized ArrayList leggiDati() throws IOException  {
	ArrayList datiConnessione=new ArrayList(20);
	RandomAccessFile file=null;
	boolean stop=true;
	

	try {
	    file=new RandomAccessFile(filename,"r");
	    while (stop){
		dati.readObject(file);
		datiConnessione.add(dati.clone());
	    }
	} catch (java.io.EOFException e) { 
	    stop=false; 
	} catch (IOException e) { 
	    System.err.println(e + " in leggiDati");
	    // return new ArrayList(1);
	} finally {
	    if (file!=null) file.close();   
	}


	return  datiConnessione;
    }

    public static void main(String args[]) throws IOException {
	/*FileDatiConnessione file=new FileDatiConnessione(args[0]);
	

	ArrayList te=file.leggiDati();

	System.out.println(te.size());
	for (int i=0; i<te.size(); i++){
	    ((DatiConnessione)te.get(i)).stampa(System.out);
	    System.out.println(((DatiConnessione)te.get(i)).hashCode());
	}
	*/

    }

    

    

}





