/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import gdistasi.StarzaNet.server.Environment;

import java.util.ArrayList;
import java.util.logging.Level;

public class BestConnessione implements Internet {
    ConnessioneInternet[] connessioni;
    int numConn;

    ConnessioneInternet connAttiva;
    
    
    int numConnAttiva;

    public BestConnessione(ArrayList conn){
	connessioni=new ConnessioneInternet[5];
	numConn=0;
	add(conn);
	scegliBest();	
    }

    public float calcolaCosto(){
	return connAttiva.calcolaCosto();
    }

    public void add(ArrayList connessione){
	for (int i=0; i<connessione.size(); i++){
	    addConnessione((ConnessioneInternet)connessione.get(i));
	}

    }

    public void addConnessione(ConnessioneInternet conn){
	connessioni[numConn]=conn;
	numConn++;
       
	//System.out.println(connessioni[0]+"ae");
    }

    public long getFine(){
	return connAttiva.getFine();
    }

    public void scegliBest(){
	int best=0;
	long currTime=System.currentTimeMillis();
	long timeParagone=currTime+1000*60*60; 
	float punteggio=0,newPunteggio=0;

	punteggio=connessioni[best].getPunteggio(currTime,timeParagone);
	if (Environment.debug>5) System.out.println(punteggio+connessioni[best].toString());

	for (int i=1; i<numConn; i++){
	    newPunteggio=connessioni[i].getPunteggio(currTime,timeParagone);
	    System.out.println(connessioni[i].toString()+
			       " punteggio: "+newPunteggio);

	    if (punteggio>newPunteggio){
		best=i;
		punteggio=newPunteggio;
	    }
	    
	}

	connAttiva=connessioni[best];

	Environment.getLogger().log(Level.INFO,"Connessione scelta: "+connAttiva.toString());
	
	//System.out.println(connAttiva+"etaetae"+connAttiva.toString());
	//System.out.println(connessioni[1]);	
    }

    public float getCostoFisso(){
	return connAttiva.getCostoFisso();
    }

    public float costoTotale(){
	return connAttiva.costoTotale();
    }

    public boolean isAttiva(){
	return connAttiva.isAttiva();

    }

    public long getInizio(){
	return connAttiva.getInizio();
    }

    public long getDurata(){
	return connAttiva.getDurata();
    }

    public void start(){
	scegliBest();
	connAttiva.start();
    }

    public String toString(){
	String ret=null;

	if (connAttiva!=null)
	    ret=connAttiva.toString();
	else ret="";


	return  ret;

    }

    public void stop(){
	for (int i=0; i<numConn; i++)
	  connAttiva.stop();
    }


}













































