/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import gdistasi.StarzaNet.server.Conf;
import gdistasi.StarzaNet.server.Environment;
import gdistasi.StarzaNet.server.Util;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class ConnessioneInternet extends ConnessioneTelefonica implements Internet  {
    String[] comandoPerCollegare,comandoPerScollegare,comandoStatus;
    String[] comandoPerAggOrario={};
    Logger log;

    //protected boolean attiva;
    static String[] ipmasq={"/usr/sbin/ipmasq"};
    boolean simulazione;
    static int connessioni=0;


    public ConnessioneInternet(Node conn) throws SAXException,ParserConfigurationException,IOException  {
	Node n;
	Element connessione=(Element)conn;
	String fileTariffa;
	connessioni++;
	log=Environment.getLogger();
	log.log(Level.INFO,"Connessione "+connessioni);
	

	n=connessione.getElementsByTagName("connetti").item(0);
	comandoPerCollegare=Conf.parseString(Util.parseSlash(n.getFirstChild().getNodeValue()));
	
	log.log(Level.INFO,"Comando per connettere: "+Util.toString(comandoPerCollegare));
	
	n=connessione.getElementsByTagName("disconnetti").item(0);
	comandoPerScollegare=Conf.parseString(Util.parseSlash(n.getFirstChild().getNodeValue()));

	log.log(Level.INFO,"Comando per disconnettere: "+Util.toString(comandoPerScollegare));

	if (connessione.getElementsByTagName("status").getLength()>0){
	    n=connessione.getElementsByTagName("status").item(0);
	    comandoStatus=Conf.parseString(Util.parseSlash(n.getFirstChild().getNodeValue()));
	    simulazione=false;
	    log.log(Level.INFO,"Comando per controllare: "+Util.toString(comandoStatus));
	} else { 
	    simulazione=true;
	    log.warning("Non sar controllato lo stato della connessione");
	}
	
	n=connessione.getElementsByTagName("tariffa").item(0);
	fileTariffa=Util.parseSlash(n.getFirstChild().getNodeValue());

	setTariffa(new TariffaXml(Environment.getDirTariffe()+fileTariffa.trim(),log));

    }

    public long getInizio(){
	return orarioAvvio;
    }

  

    public boolean isAttiva(){
	boolean ris=false;

	if (simulazione)
	    ris=isAttiva;
	else {
	    ris=controllaSeAttiva();

	}

	if (ris==false) super.stop();

	return ris;
	

    }



    public boolean controllaSeAttiva(){
	boolean ris=false;

	if (Util.esegui(comandoStatus)==0) ris=true;

	return ris;
    }


    public void start() /*throws IOException*/ {
	
	collegati();
	super.start();
	//	System.out.println(tariffa);
 
	//	return ris;
    }


    public void stop() /*throws Exception*/ {
     	scollegati();

	super.stop();
		
	//return ris;
    }

    public String toString(){
	return tariffa.toString();
    }

   
    protected int collegati() /*throws Exception*/ {
	//esegui(ipmasq);
	//esegui(comandoPerAggOrario);
	return Util.esegui(comandoPerCollegare);
    }

    protected int scollegati() /*throws java.io.IOException*/ {
	boolean ris=false;
	int ret=1;

	Util.esegui(comandoPerScollegare);
	
	if (simulazione) ris=true;
	else ris=!controllaSeAttiva();

	if (ris) ret=0;

	return ret;
    }

   





}




