/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;


public class ConnessioneTelefonica  {
    Tariffa tariffa;
    
    long orarioAvvio;
    long fine;

    double giaCalcolato;
    long tempoGiaCalcolato;
    
    boolean isAttiva;


    //protected GregorianCalendar calendario;

    public ConnessioneTelefonica(Tariffa tariffa){
	//calendario=new GregorianCalendar();
	setTariffa(tariffa);
    } 

    public ConnessioneTelefonica(){

    }

    public void setTariffa(Tariffa tariffa){
	this.tariffa=tariffa;
    }

    public float getPunteggio(long inizio,long time){
	return tariffa.getPunteggio(inizio,time);
    }

    public void start() /*throws Exception*/ {
	orarioAvvio=System.currentTimeMillis();
	tariffa.setInizio(orarioAvvio);
	tempoGiaCalcolato=orarioAvvio;
	giaCalcolato=0;
	isAttiva=true;

    }

    public float costoTotale(){
	return calcolaCosto()+getCostoFisso();
    }

    public void stop() /*throws Exception*/ {
	isAttiva=false;
    }

    public  float getCostoFisso(){
	return tariffa.getCostoFisso();
    }

    public long getDurata(){
	return fine-orarioAvvio;
    }

    public long getInizio(){
	return orarioAvvio;
    }

    public long getFine(){
	return fine;
    }

    public float calcolaCosto(){
 	return calcolaCosto(System.currentTimeMillis());
    }
    
    public float calcolaCosto(long time){
	double ris=0,cal=0;

	if (isAttiva) {
	    fine=time;
	    cal=calcolaCosto(tempoGiaCalcolato,fine);
	    
	}
	
	ris=giaCalcolato+cal;
	
	//System.out.println("costo del secondo"+ris);	

	if ((fine-tempoGiaCalcolato)>1000*60*5) {
	    giaCalcolato=ris;
	    tempoGiaCalcolato=fine;
	}

	return (float)ris;
    }

    public float calcolaCosto(long inizio,long fine){
	long adesso=fine;
	long temp=inizio;
	float costoParziale=0;

	while (temp<=adesso){
	    costoParziale+=tariffa.calcolaCostoDelSecondo(temp);
	    temp+=1000;
	}

	//System.out.println(costoParziale+" "+inizio +" " + fine);
	return costoParziale;
    }    



    public static void main (String[] argc) throws Exception {
	/*	ConnessioneTelefonica conn=new ConnessioneTelefonica(new Telecom());
	conn.start();
	
	Thread.sleep(1000*60*120);
	*/
	
	//System.out.println("teah");
	//Syste.out.println(""+conn.calcolaCosto());

    }


}
 















