/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import gdistasi.StarzaNet.server.Environment;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Iterator;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class Fascia {
    Orario inizio;
    Orario fine;
    
    long durata;
    boolean conDurata;
    boolean allHour;

    long tempoDiAttivazione;

    ArrayList date;

    static final int EASTER=10;

    Date dateInizio,dateFine;


    float scatto;
    float costo;
    boolean selectedEaster;
    Calendar calendar;
    boolean[] listaGiorni;
    long afterTime;

    public Fascia(Orario iniz, Orario fine, int giornoIniz, int giornoFin){
	this();
	this.inizio=iniz;
	this.fine=fine;
	set(giornoIniz,giornoFin);
	this.calendar=new GregorianCalendar();

    }

    Fascia(){
	this.listaGiorni=new boolean[8];
	date=new ArrayList();
    }

    

    public Fascia(Node node){
	this();
	Element fascia=(Element)node;
	Node n;
	String str;
	int giornoInizio,giornoFine;
	this.calendar=new GregorianCalendar();
	
	n=fascia.getElementsByTagName("giornoinizio").item(0);
	giornoInizio=getGiorno(n.getFirstChild().getNodeValue());
	
	n=fascia.getElementsByTagName("giornofine").item(0);
	giornoFine=getGiorno(n.getFirstChild().getNodeValue());
	
	set(giornoInizio,giornoFine);

	n=fascia.getElementsByTagName("orainizio").item(0);
	inizio=getOrario(n.getFirstChild().getNodeValue());
	
	n=fascia.getElementsByTagName("orafine").item(0);
	fine=getOrario(n.getFirstChild().getNodeValue());
	    
	NodeList lis;
	lis=fascia.getElementsByTagName("scatto");
	if (lis!=null && lis.getLength()>0){
	    str=lis.item(0).getFirstChild().getNodeValue();
	    scatto=Float.parseFloat(str);
	    System.out.println(scatto+" afea ");
	} else {
	    scatto=-1;
	}

	    
	n=fascia.getElementsByTagName("costo").item(0);
	str=n.getFirstChild().getNodeValue();
	costo=Float.parseFloat(str);

    }

    public void addDay(int day){
	if (day==EASTER) selectedEaster=true;
	else listaGiorni[day]=true;
    }

    public void setAllDays(){
	for (int i=0; i<listaGiorni.length; i++){
	    listaGiorni[i]=true;
	}
    }

    public void set(int giornoInizio,int giornoFine){
	int i;

	if (Environment.debug>7){
	    System.out.println("setto: da" +giornoInizio+" a "+giornoFine);

	}

	if (giornoInizio<=giornoFine){
	    for (i=giornoInizio; i<=giornoFine; i++)
		listaGiorni[i]=true;
	} else {
	    for (i=0; i<=giornoFine; i++) 
		listaGiorni[i]=true;
	    for (i=giornoInizio; i<listaGiorni.length; i++) 
		listaGiorni[i]=true;

	}

	/*	for (i=0; i<listaGiorni.length; i++){
	    System.out.println(listaGiorni[i]+" ");
	    }*/

    }

    public void setAllHour(){
	this.allHour=true;
    }

    public boolean isInFascia(long data){
	Orario or=new Orario(data);
	int day,dateDay,dayOfYear;
	boolean retDay=false,retHour=false;
	boolean ret=false;

	calendar.setTimeInMillis(data);
	day=calendar.get(Calendar.DAY_OF_WEEK);

	if (listaGiorni[day]) retDay=true;
	
	if (allHour) retHour=true; 
	else {
	    if (or.compreso(inizio,fine))
		retHour=true;
	    //    System.out.println("RET"+retHour);
	}

	dayOfYear=calendar.get(Calendar.DAY_OF_YEAR);
        Iterator it=date.iterator();
	while (it.hasNext()){
	    calendar.setTimeInMillis(((Date)it.next()).getTime());
	    dateDay=calendar.get(Calendar.DAY_OF_YEAR);
	    if (dateDay==dayOfYear){
		retDay=true;
		break;
	    }
	}
	
	return retDay && retHour;
    }

    public long afterTime(){
	return afterTime;

    }
    
    public void setOrario(Orario inizio,Orario fine){
	this.inizio=inizio;
	this.fine=fine;

    }

    public float getCosto(){
	return costo;
    }
    
    public float getCostoFisso(){
	return scatto;
    }

    public Orario getOrario(String data){
	SimpleDateFormat format=new SimpleDateFormat("HH:mm");
 	return new Orario(format.parse(data,new ParsePosition(0)));

    }
    
    public String toString(){
	StringBuffer str=new StringBuffer();
	//	str.append(inizio+" "+fine+" "+giornoInizio+" "+giornoFine+" "+costo);
	return str.toString();

    }

    public void addInterDate(Date inizio,Date fine){
	dateInizio=inizio;
	dateFine=fine;
    }

    public void addData(Date data){
	date.add(data);

    }

    public int getGiorno(String g){
	int ret=-1;
	
	g=g.trim();
	if (g.equals("lun")) ret=Calendar.MONDAY;
   	if (g.equals("mar")) ret=Calendar.TUESDAY;
	if (g.equals("mer")) ret=Calendar.WEDNESDAY;
	if (g.equals("gio")) ret=Calendar.TUESDAY;
	if (g.equals("ven")) ret=Calendar.FRIDAY;
	if (g.equals("sab")) ret=Calendar.SATURDAY;
	if (g.equals("dom")) ret=Calendar.SUNDAY;

	if (ret==-1) 
	    Environment.getLogger().warning("Giorno: "+g+" non riconosciuto in definizione tariffa");

	return ret;

    }


}
