/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.StringTokenizer;

public class Orario {
    int ora;
    int minuti;
    GregorianCalendar calendario;


   public Orario(int ora,int minuti){
	this.ora=ora;
	this.minuti=minuti;
	calendario=new GregorianCalendar();
    }

    public Orario(long time){
	calendario=new GregorianCalendar();
	set(time);

    }

    public Orario(Date data){
	this(data.getTime());
    }

    public Orario(String orario){
	if (orario.indexOf(":")==-1) throw new Error("errore in formato orario: "+orario);
	StringTokenizer token=new StringTokenizer(orario,":");
	ora=Integer.parseInt(token.nextToken());
	minuti=Integer.parseInt(token.nextToken());
	calendario=new GregorianCalendar();
    }

    public void set(long time){
	calendario.setTime(new Date(time));
	//calendario.set(Calendar.AM_PM,Calendar.AM);
	ora=calendario.get(Calendar.HOUR_OF_DAY);
	minuti=calendario.get(Calendar.MINUTE);
    }

    
    public long getTimeInMillis(){
	calendario.setTime(new Date(System.currentTimeMillis()));
	//System.out.println("prima"+calendario.getTime());
	//calendario.set(Calendar.AM_PM,Calendar.AM);
	calendario.set(Calendar.HOUR_OF_DAY,ora);
	calendario.set(Calendar.MINUTE,minuti);

	//System.out.println(calendario.getTime());
	return calendario.getTime().getTime();

    }

    public boolean setOra(int ora){
	boolean ris=false;
	if (ora>=0 && ora<=23){
	    this.ora=ora;
 	    ris=true;
	} else System.err.println("impossibile impostare ora: "+ora);
	return ris;
    }

    public boolean setMinuti(int minuti){
	boolean ris=false;
	if (minuti>=0 && minuti<=59){
	    this.minuti=minuti;
	    ris=true;
	} else System.err.println("impossibile impostare minuti: "+minuti);
	return ris;
    }

    public int getOra(){
	return ora;
    }

    public int getMinuti(){
	return minuti;
    }

    public boolean compreso(Orario inizio, Orario fine){
	boolean ris=false;
	if (vieneDopo(inizio.getTimeInMillis()) && !vieneDopo(fine.getTimeInMillis()))
	    ris=true;
	
	return ris;

    }

    public boolean vieneDopo(long tempo){
	boolean ris=false;
	calendario.setTime(new Date(tempo));
	calendario.set(Calendar.AM_PM,Calendar.AM);
	calendario.set(Calendar.MINUTE,minuti);
	calendario.set(Calendar.HOUR,ora);

	if (calendario.getTime().getTime()>=tempo) ris=true;
	
	return ris;
    }

    static public int minutiIntercorsi(long temp, long orarioAvvio){
	
	int ris;
	ris=(int)((temp-orarioAvvio)/60000);
	return ris;
	
    }
    
    public String toString(){
	return (""+ora+":"+minuti);

    }
    



}
















