/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import gdistasi.StarzaNet.server.Environment;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public abstract class TariffaBase implements Tariffa {
    float[][] fascie;
    Orario[] fasciePerOre;
    long inizio;
    protected GregorianCalendar calendario;

    public TariffaBase(){
	calendario=new GregorianCalendar();
    }

    public void setFascie(Orario[] fasciePerOre,float[][] fascie){
	this.fasciePerOre=fasciePerOre;
	this.fascie=fascie;
	
    }

    public void setInizio(long inizio){
	this.inizio=inizio;

    }

    public float calcolaCostoDelSecondo(long temp){
	float costo,sconto;
	costo=calcolaCostoDelSecondoSenzaSconto(temp);
	sconto=calcolaSconto(temp,costo);
	
	if (Environment.debug>=3) {
	    System.out.println(this.toString());
	    System.out.println("Costo del secondo "+temp+"="+costo);
	    System.out.println("Sconto= "+sconto);
	}
	
	return (costo-sconto);
    }

    

 public float getPunteggio(long inizio,long time){
     ConnessioneTelefonica temp=new ConnessioneTelefonica(this);
     temp.start();
     float punteggio=temp.calcolaCosto(time);
     punteggio+=getCostoFisso();
     
     //System.out.println(this+" "+punteggio);

     return punteggio;
 }


    protected float calcolaCostoDelSecondoSenzaSconto(long temp){
	float ris=0;
	calendario.setTime(new Date(temp));
	int i;
	
	for (i=0; i<fasciePerOre.length; i++){
	    if (i+1==fasciePerOre.length) break;
	    if ((fasciePerOre[i].getTimeInMillis()<temp) && 
		(fasciePerOre[i+1].getTimeInMillis()>temp))
		break;
	    
	}
	
	int j=calendario.get(Calendar.DAY_OF_WEEK)-1;

	

	ris=fascie[j][i];
	
	//System.out.println("ris="+ris);

	ris=ris/60;
	//System.out.println("AAA"+j+" "+i+ toString()+" " + ris);

	//if (inizio!=0)
	//    ris=ris-calcolaSconto(temp,ris);
	//else System.err.println("errore in inizio per calcolo tariffa");
	
	//System.out.println("AAA"+j+" "+i+ toString()+" " + ris);

	return ris;

    }

    public String toString(){
	return getClass().getName();

    }

    abstract float calcolaSconto(long temp,float costo);

     static public Tariffa tariffaScelta(String tariffa) {
	Tariffa ret=null;
	if (equalsCaseIns("InfostradaBase",tariffa)) ret= new InfostradaBase();
	if (equalsCaseIns("Telecom",tariffa)) ret= new Telecom();
	if (equalsCaseIns("Wind",tariffa)) ret= new Wind();

	return ret;
    }

    static public boolean equalsCaseIns(String uno, String due){

	uno=uno.toUpperCase();
	due=due.toUpperCase();

	return (uno.equals(due));

    }




}






