/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.telefono;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;

public class TariffaKppp implements Tariffa {
    FileInputStream input;
    BufferedReader reader;

    ArrayList tariffe;

    String name;

    String currency;

    float costoMinimo;
    float scattoAllaRisposta;

    long inizio;
    
    float standard;
    long afterTime;

    public TariffaKppp(File file) throws IOException {
	input=new FileInputStream(file);
	reader=new BufferedReader(new InputStreamReader(input));
	tariffe= new ArrayList();
	parseTariffa();


    }

    public void setInizio(long inizio){
	this.inizio=inizio;
    }
    

    
    public float getCostoFisso(){
	return 0;

    }

    public float getPunteggio(long a,long b){
	return 325235;
	
    }

    
    protected void parseTariffa() throws IOException {
	String linea=null;
	StringTokenizer tokenSpazio;
	StringTokenizer token2;
	String letto;

	ArrayList param=null;



	while ((linea=reader.readLine())!=null){
	    linea=linea.trim();
	    if (linea.charAt(0)=='#') continue;
	    

	    if (linea.indexOf("=")!=-1){

		tokenSpazio=new StringTokenizer(linea,"=");
		
		letto = tokenSpazio.nextToken();
		
		if (letto.equals("name")){
		    name=tokenSpazio.nextToken();
		} else if (letto.equals("minimum_costs")){
		    costoMinimo=Float.parseFloat(tokenSpazio.nextToken());
		} else if (letto.equals("per_connection")){
		    scattoAllaRisposta=Float.parseFloat(tokenSpazio.nextToken());
		} else if (letto.equals("currency_symbol")){
		    currency=tokenSpazio.nextToken();
		} else if (letto.equals("flat_init_costs")){
		    param=parseParam(tokenSpazio.nextToken());
		} else if (letto.equals("default")){
		    param=parseParam(tokenSpazio.nextToken());
		    
		    standard=getCostoAlMinuto((String)param.get(0),(String)param.get(1));
		    if (param.size()==3) 
			afterTime=Integer.parseInt((String)param.get(2));
			
		} else {
		    System.err.println("error in parsing:" + letto);
		}
	    }

	    int punt=0;
	    String str;
	    StringTokenizer tokenPunti,token;
	    
	    String first,last;
	    String lista;
	    Fascia f;


	    if (linea.startsWith("on")){
		f=new Fascia();
		punt=2;
		
		token=new StringTokenizer(linea," ");
		
		if (!token.nextToken().equals("on")) throw new Error("errore in tariffa 1");

		lista=token.nextToken();

		String[] arLista=parseParamVir(lista);

		if (arLista.length==0) f.setAllDays();
		for (int i=0; i<arLista.length; i++){
		    if (arLista[i].indexOf("..")==-1){
			//item singolo
			if (arLista[i].indexOf("/")!=-1){
			    //data singola
			    f.addData(parseData(arLista[i]));			    
			} else {
			    //giorno singolo
			    f.addDay(parseDay(arLista[i]));
			}
			
			
		    } else {
			//giorno multiplo
			Date dataInizio=null,dataFine=null;
			int giornoInizio=-1,giornoFine=-1;
			
			tokenPunti=new StringTokenizer(arLista[i],"(..)");
			String t=tokenPunti.nextToken();
			if (t.indexOf("/")!=-1){
			    //data singola
			    dataInizio=parseData(t);			    
			} else {
			    //giorno singolo
			    giornoInizio=parseDay(t);
			}
			t=tokenPunti.nextToken();
			if (t.indexOf("/")!=-1){
			    //data singola
			    dataFine=parseData(t);			    
			} else {
			    //giorno singolo
			    giornoFine=parseDay(t);
			}
			if (giornoInizio!=-1){
			    f.set(giornoInizio,giornoFine);
			} else {
			    f.addInterDate(dataInizio,dataFine);
			}
			
			
		    }
		}
		
		String tokenBetween;
		StringTokenizer tokens;
		if (!token.nextToken().equals("between")) 
		    throw new Error("errore 2");

		tokenBetween=token.nextToken();
		if (tokenBetween.length()>2){
		    tokenBetween=tokenBetween.substring(1,tokenBetween.length()-2);
		    
		    if (tokenBetween.indexOf("..")!=-1){
			tokenPunti=new StringTokenizer(tokenBetween,"(..)");
			
			Orario orarioInizio,orarioFine;
			orarioInizio=new Orario(token.nextToken());
			orarioFine=new Orario(token.nextToken());
			f.setOrario(orarioInizio,orarioFine);
		    } else throw new Error("errore in tariffa 3");		
		} else f.setAllHour();
	    }
	    
	}			    
	
    }

	    
    
    protected Date parseData(String data){
	SimpleDateFormat format=new SimpleDateFormat("MM/dd");
	return format.parse(data,new ParsePosition(0));
    }

    protected String[] parseParamVir(String str){
	ArrayList ret=new ArrayList(6);
	StringTokenizer token=new StringTokenizer(str," ,()");
	while (token.hasMoreTokens()){
	    ret.add(token.nextToken());
	}
	return (String[])ret.toArray();
    }

    public float calcolaCostoDelSecondo(long temp){
	return 0;

    }
 
	    	
       
    protected float getCostoAlMinuto(String strCosto, String strDurataScatto){
	float costo;
	int durataScatto;
	costo=Float.parseFloat(strCosto);
	durataScatto=Integer.parseInt(strDurataScatto);
	return costo/durataScatto*60;
    }

    
    protected ArrayList parseParam(String str){
	ArrayList ret=new ArrayList();
	
	StringTokenizer token;
	token = new StringTokenizer(str,"(), ");
	while (token.hasMoreTokens()){
	    ret.add(token.nextToken());
	}
       	
	
	return ret;


    }

    public int parseDay(String day){
	int ret=-1;
	if (day.equals("monday")){
	    ret=Calendar.MONDAY;
	}
	if (day.equals("tuesday")){
	    ret=Calendar.TUESDAY;
	}
	
	
	if (day.equals("friday")){
	    ret=Calendar.FRIDAY;
	}
	if (day.equals("sunday")){
	    ret=Calendar.SUNDAY;
	}
	
	if (day.equals("easter")){
	    return Fascia.EASTER;
	}

	return ret;

    }

    

}

    










